<template>
  <div>
    <SidebarAdmin />
    <div class="container-admin">
      <div class="icon-step">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          width="26"
          height="26"
          fill="currentColor"
          class="bi bi-pencil-square"
          viewBox="0 0 16 16"
        >
          <path
            d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"
          />
          <path
            fill-rule="evenodd"
            d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"
          />
        </svg>
      </div>
      <form @submit.prevent class="mt-4">
        <div>
          <h4 class="fw-bold">Profile Peserta</h4>
          <hr />
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="nik" class="form-label"
                  >Nomor Induk Kependudukan</label
                >
                <input
                  type="text"
                  class="form-control"
                  id="nik"
                  placeholder="Ketik nik"
                  v-model="participant.nik"
                  required
                />
              </div>
              <div class="mb-3">
                <label for="tanggalLahir" class="form-label"
                  >Tanggal Lahir</label
                >
                <input
                  type="date"
                  class="form-control"
                  id="tanggalLahir"
                  placeholder="Ketik tanggal lahir"
                  v-model="participant.dob"
                  required
                />
              </div>
              <div class="mb-3">
                <label for="alamat" class="form-label">Alamat</label>
                <textarea
                  class="form-control"
                  id="alamat"
                  rows="3"
                  placeholder="ketik alamat"
                  v-model="participant.address"
                  required
                ></textarea>
              </div>
              <div class="mb-3">
                <label for="email" class="form-label">Email</label>
                <input
                  type="email"
                  class="form-control"
                  id="email"
                  placeholder="Ketik email"
                  v-model="participant.email"
                  required
                />
              </div>
            </div>

            <div class="col-6">
              <div class="mb-3">
                <label for="namaLengkap" class="form-label">Nama Lengkap</label>
                <input
                  type="text"
                  class="form-control"
                  id="namaLengkap"
                  placeholder="Ketik nama lengkap"
                  v-model="participant.name"
                  required
                />
              </div>
              <div class="mb-3">
                <label for="jenisKelamin" class="form-label"
                  >Jenis Kelamin</label
                >
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="jenisKelamin"
                  v-model="participant.gender"
                  required
                >
                  <option
                    value="Laki-laki"
                    :selected="participant.gender === 'Laki-laki'"
                  >
                    Laki-laki
                  </option>
                  <option
                    value="Perempuan"
                    :selected="participant.gender === 'Perempuan'"
                  >
                    Perempuan
                  </option>
                </select>
              </div>
              <div class="mb-3">
                <label for="nomorHP" class="form-label">Nomor Handphone</label>
                <input
                  type="text"
                  class="form-control"
                  id="nomorHP"
                  placeholder="Ketik nomor handphone"
                  v-model="participant.phoneNumber"
                  required
                />
              </div>
            </div>
          </div>
        </div>
        <div class="mt-5">
          <h4 class="fw-bold">Informasi Pekerjaan</h4>
          <hr />
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="jenisPekerjaan" class="form-label"
                  >Jenis Pekerjaan</label
                >
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="jenisPekerjaan"
                  v-model="job.idJobType"
                  required
                >
                  <option value="" selected>Pilih jenis pekerjaan...</option>
                  <option
                    :value="jobType.idJobType"
                    v-for="jobType in jobTypes"
                    :key="jobType.idJobType"
                  >
                    {{ jobType.nameJobType }}
                  </option>
                </select>
              </div>

              <div class="mb-3">
                <label for="provinsi" class="form-label">Provinsi</label>
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="provinsi"
                  @change="onChangeProvince($event)"
                  v-model="idProvince"
                  required
                >
                  <option value="" selected>Pilih provinsi...</option>
                  <option
                    :value="province.idProvince"
                    v-for="province in provinces"
                    :key="province.id"
                  >
                    {{ province.nameProvince }}
                  </option>
                </select>
              </div>
              <div class="mb-3">
                <label for="noTelepon" class="form-label">No. Telepon</label>
                <input
                  type="text"
                  class="form-control"
                  id="noTelepon"
                  placeholder="Ketik no. telepon"
                  v-model="job.phoneJob"
                  required
                />
              </div>
              <div class="mb-3">
                <label for="penghasilan" class="form-label"
                  >Penghasilan Per Bulan</label
                >
                <input
                  type="text"
                  class="form-control"
                  id="penghasilan"
                  placeholder="Ketik penghasilan per bulan"
                  v-model="job.avrIncomeMonthly"
                  required
                />
              </div>
            </div>
            <div class="col-6">
              <div class="mb-3">
                <label for="pekerjaan" class="form-label">Pekerjaan</label>
                <input
                  type="text"
                  class="form-control"
                  id="pekerjaan"
                  placeholder="Ketik pekerjaan"
                  v-model="job.nameJob"
                  required
                />
              </div>

              <div class="mb-3">
                <label for="wilayah" class="form-label">Wilayah</label>
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="wilayah"
                  v-model="idRegion"
                  required
                >
                  <option value="" selected>Pilih wilayah...</option>
                  <option
                    :value="region.idRegion"
                    v-for="region in regions"
                    :key="region.idRegion"
                  >
                    {{ region.nameRegion }}
                  </option>
                </select>
              </div>
              <div class="mb-3">
                <label for="email" class="form-label">Email</label>
                <input
                  type="email"
                  class="form-control"
                  id="email"
                  placeholder="Ketik no. telepon"
                  v-model="job.emailJob"
                  required
                />
              </div>
            </div>
          </div>
        </div>
        <div class="mt-5">
          <h4 class="fw-bold">Informasi Program</h4>
          <hr />
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="kantorCabang" class="form-label"
                  >Kantor Cabang</label
                >
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="kantorCabang"
                  v-model="participant.idBranch"
                  required
                >
                  <option value="" selected>Pilih kantor cabang...</option>
                  <option
                    :value="branch.idBranch"
                    v-for="branch in brancies"
                    :key="branch.idBranch"
                  >
                    {{ branch.nameBranch }}
                  </option>
                </select>
              </div>
              <div class="mb-3">
                <label for="program" class="form-label">Program</label>
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="program"
                  required
                  v-model="participant.idProgram"
                >
                  <option value="" selected>Pilih program...</option>
                  <option
                    :value="program.idProgram"
                    v-for="program in programs"
                    :key="program.idProgram"
                  >
                    {{ program.nameProgram }}
                  </option>
                </select>
              </div>
            </div>
            <div class="col-6">
              <div class="mb-3">
                <label for="periodePembayaran" class="form-label"
                  >Periode Pembayaran</label
                >
                <select
                  class="form-select"
                  aria-label="Default select example"
                  id="periodePembayaran"
                  v-model="participant.idPaymentPeriod"
                  required
                >
                  <option value="" selected>Pilih periode pembayaran...</option>
                  <option
                    :value="paymentPeriod.idPaymentPeriod"
                    v-for="paymentPeriod in paymentPeriods"
                    :key="paymentPeriod.idPaymentPeriod"
                  >
                    {{ paymentPeriod.typePaymentPeriod }} bulan
                  </option>
                </select>
              </div>
            </div>
          </div>
        </div>
        <div class="d-flex my-4 justify-content-end gap-2">
          <!-- Button trigger modal -->
          <button
            type="button"
            class="btn btn-danger"
            data-bs-toggle="modal"
            data-bs-target="#exampleModal"
          >
            Hapus
          </button>
          <button type="submit" class="btn btn-primary" @click="update">
            Update
          </button>
        </div>
      </form>
    </div>

    <!-- Modal -->
    <div
      class="modal fade"
      id="exampleModal"
      tabindex="-1"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title fw-bold" id="exampleModalLabel">
              Hapus Data
            </h5>
            <button
              type="button"
              class="btn-close"
              data-bs-dismiss="modal"
              aria-label="Close"
            ></button>
          </div>
          <div class="modal-body">
            <p>Apakah Anda yakin ingin menghapus data peserta ini?</p>
          </div>
          <div class="modal-footer">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
            >
              Kembali
            </button>
            <button
              type="button"
              class="btn btn-danger"
              data-bs-dismiss="modal"
              @click="hapus"
            >
              Hapus
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import SidebarAdmin from "@/components/SidebarAdmin.vue";
import moment from "moment/moment";
import axios from "axios";

export default {
  name: "ParticipantDetailView",
  components: {
    SidebarAdmin,
  },
  data() {
    return {
      participant: {},
      jobTypes: [],
      provinces: [],
      regions: [],
      brancies: [],
      programs: [],
      paymentPeriods: [],
      job: {},

      idProvince: "",
      idRegion: "",
    };
  },
  methods: {
    setData() {
      this.participant.dob = moment(this.participant.dob).format("YYYY-MM-DD");
    },
    getParticipant() {
      axios
        .get(
          "http://localhost:3000/participant/detail/" + this.$route.params.id
        )
        .then((response) => {
          this.participant = response.data.data[0];

          this.getJob(this.participant.idJob);
          this.setData();
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getJobTypes() {
      axios
        .get("http://localhost:3000/jobtype/view")
        .then((response) => {
          this.jobTypes = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getProvinces() {
      axios
        .get("http://localhost:3000/province/view")
        .then((response) => {
          this.provinces = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getRegions(idProvince) {
      axios
        .get("http://localhost:3000/region/view/" + idProvince)
        .then((response) => {
          this.regions = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getBrancies(idProvince) {
      axios
        .get("http://localhost:3000/branch/view/" + idProvince)
        .then((response) => {
          this.brancies = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getPrograms() {
      axios
        .get("http://localhost:3000/program/view")
        .then((response) => {
          this.programs = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getPaymentPeriods() {
      axios
        .get("http://localhost:3000/period/view")
        .then((response) => {
          this.paymentPeriods = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getJob(idJob) {
      axios
        .get("http://localhost:3000/job/detail/" + idJob)
        .then((response) => {
          this.job = response.data.data[0];
          let address = (this.job.addressJob ?? "").split("-");
          this.idProvince = parseInt(address[0]);
          this.getRegions(this.idProvince);
          this.getBrancies(this.idProvince);
          this.idRegion = parseInt(address[1]);

          console.log(this.job);
        })
        .catch((error) => {
          console.log(error);
        });
    },
    onChangeProvince(event) {
      let id = event.target.value;
      this.idRegion = "";
      this.participant.idBranch = "";
      this.getRegions(id);
      this.getBrancies(id);
    },
    update() {
      if (
        this.participant.nik &&
        this.participant.name &&
        this.participant.dob &&
        this.participant.gender &&
        this.participant.address &&
        this.participant.phoneNumber &&
        this.participant.email &&
        this.job.idJobType &&
        this.idProvince &&
        this.job.phoneJob &&
        this.job.avrIncomeMonthly &&
        this.job.nameJob &&
        this.idRegion &&
        this.job.emailJob &&
        this.participant.idBranch &&
        this.participant.idProgram &&
        this.participant.idPaymentPeriod
      ) {
        this.job.addressJob = this.idProvince + " - " + this.idRegion;

        let filter = this.paymentPeriods.find((e) => {
          return e.idPaymentPeriod === this.participant.idPaymentPeriod;
        });

        let totalJKK =
          (1 / 100) *
          parseInt(this.job.avrIncomeMonthly) *
          filter.typePaymentPeriod;

        let totalJHT =
          (2 / 100) *
          parseInt(this.job.avrIncomeMonthly) *
          filter.typePaymentPeriod;

        this.participant.totalIuranJkk = totalJKK;
        this.participant.totalIuranJht = totalJHT;
        this.participant.totalBayar = totalJKK + totalJHT + 6800;
        this.updateJob(this.job.idJob);
        this.updateParticipant(this.participant.idParticipant);
      }
    },
    updateJob(idJob) {
      delete this.job.idJob;
      axios
        .put("http://localhost:3000/job/edit/" + idJob, this.job)
        .then(() => {})
        .catch(() => {});
    },
    updateParticipant(idParticipant) {
      delete this.participant.idParticipant;
      axios
        .put(
          "http://localhost:3000/participant/edit/" + idParticipant,
          this.participant
        )
        .then(() => {
          this.$toast.success("Berhasil mengubah data peserta.", {
            type: "success",
            position: "top-right",
            duration: 3000,
            dismissible: true,
          });
          this.$router.push({
            path: "/admin/participant",
          });
        })
        .catch(() => {
          this.$toast.success("Belum berhasil mengubah data peserta.", {
            type: "error",
            position: "top-right",
            duration: 3000,
            dismissible: true,
          });
        });
    },
    hapus() {
      axios
        .delete("http://localhost:3000/job/delete/" + this.participant.idJob)
        .then(() => {})
        .catch(() => {});

      axios
        .delete(
          "http://localhost:3000/participant/delete/" +
            this.participant.idParticipant
        )
        .then(() => {
          this.$toast.success("Berhasil menghapus data peserta.", {
            type: "success",
            position: "top-right",
            duration: 3000,
            dismissible: true,
          });
          this.$router.push({
            path: "/admin/participant",
          });
        })
        .catch(() => {
          this.$toast.success("Belum berhasil menghapus data peserta.", {
            type: "error",
            position: "top-right",
            duration: 3000,
            dismissible: true,
          });
        });
    },
  },
  mounted() {
    moment.locale("id");
    this.getJobTypes();
    this.getProvinces();
    this.getPrograms();
    this.getPaymentPeriods();
    this.getParticipant();
  },
};
</script>

<style>
</style>